LeetCode1:
给定一个整数数组 nums 和一个目标值 target,在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。
可以假设每种输入只会对应一个答案。但是,数组中同一个元素不能使用两遍。
示例 1:
给定 nums = [2, 7, 11, 15], target = 9
因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]
解法一:
两个for循环遍历:
class Solution {
public int[] twoSum(int[] nums, int target) {
int res[] = new int[2];
for(int i = 0; i < nums.length; i++){
for(int j = i + 1; j < nums.length; j++){
if(nums[i] + nums[j] == target){
res[0] = i;
res[1] = j;
break;
}
}
}
return res;
}
}
解法二:
使用Hash表:
class Solution {
public int[] twoSum(int[] nums, int target) {
int res[] = new int[2];
Map map= new HashMap<>();
for(int i = 0; i < nums.length; i++){
map.put(nums[i], i);
}
for(int i = 0; i < nums.length; i++){
int temp = target - nums[i];
if(map.containsKey(temp) && map.get(temp) != i){
res[0] = map.get(temp);
res[1] = i;
}
}
return res;
}
}
知识点:
主要hashmap方法的使用:
import java.util.HashMap;
public class Test {
public static void main(String[] args) {
// TODO Auto-generated method stub
//(key, value)
HashMap map = new HashMap();
//向map中添加值
map.put("jiang", 1);
map.put("wen", 2);
System.out.println(map);
//取值(得到map中,key对应的value)
int temp = map.get("jiang");
System.out.println(temp);
//判断map是否为空
System.out.println(map.isEmpty());
//判断是否含有key
System.out.println(map.containsKey("jiang"));
//判断是否含有value
System.out.println(map.containsValue(1));
//删除key对应的value
map.remove("jiang");
System.out.println(map.get("jiang"));
//显示所有map的value值
System.out.println(map.values());
//元素个数
System.out.println(map.size());
}
}